"use strict";
const gd      = require('../helper/gd.js');
const support = require('../helper/support.js');

module.exports = function(server, arg, cb) {

  const conf    = gd.conf()
  const type    = conf.config.type
  const version = conf.config.version

  if(support.isCommandExcluded('aggregate', true)){
    cb ? cb() : gd.autoClose()
    return;
  }

  server = gd.server(server);

  var agg = ''
  if(type === 'drupal') {

    var change = arg == 'true' ? '1' : '0';

    if(conf.config.version !== '7.x') {
      agg+= 'drush -y config-set system.performance css.preprocess ' + change + ' && ';
      agg+= 'drush -y config-set system.performance js.preprocess ' + change + '';
    }
    else {
      agg+= 'drush vset preprocess_css ' + change + ' --yes && ';
      agg+= 'drush vset preprocess_js ' + change + ' --yes && ';
      //agg+= 'drush vset cache ' + change + ' --yes && ';
      agg+= 'drush vset block_cache ' + change + ' --yes';
    }
  }

  var message = 'Enabled aggregation css & js on ' + server;
  if(arg != 'true') {
    message = 'Disabled aggregation css & js on ' + server;
  }

  gd.throbber.start(message.replace('abled', 'abling'));
  
  if(server === 'dev') { 
    gd.exec('cd ' + conf.site_local + ' && ' + agg, cb, message);
    return;
  }


  var C = conf.servers[server];
  var S = C.user + '@' + C.ip;

  var cmd = '';

  cmd+= `ssh -T -p ${C.port} ${S} `;

  cmd+= '"';
  cmd+= 'cd ' + C.site;
  cmd+= ' && ';
  cmd+= agg;
  cmd+= '"';


  gd.exec(cmd, cb, message);
};
