"use strict";
const gd      = require('../helper/gd.js');
const support = require('../helper/support.js');

module.exports = function(server, cb) {

  const conf    = gd.conf()
  const type    = conf.config.type
  const version = conf.config.version

  if(support.isCommandExcluded('clear-cache')){
    cb ? cb() : gd.autoClose()
    return;
  }

  server = gd.server(server);

  const C = conf.servers[server];
  const S = C.user + '@' + C.ip;

  let cc = ''
  let site = C.site
  if(type === 'drupal') {

    if(version !== '7.x') {
      cc = 'drush cache-rebuild';
    }
    else {
      cc = 'drush cc all';
    }
  }
  else if(type === 'symfony') {
    cc = 'php app/console cache:clear';

    if(server !== 'dev') {
      cc+= ' --env=prod';
    }
    // on symfony cache must be clear from the project main directory
    site += '../'
  }

  gd.throbber.start(`Clearing cache on ${server}`);

  let cmd = '';

  if(server === 'dev') {
    gd.exec('cd ' + conf.site_local + ' && ' + cc, cb, `Cache cleared on ${server}`);
    return;
  }

  cmd+= `ssh -T -p ${C.port} ${S} `;

  cmd+= '"';
  cmd+= 'cd ' + site;
  cmd+= ' && ';
  cmd+= cc;
  cmd+= '"';

  gd.exec(cmd, cb, `Cache cleared on ${server}`);
};
