"use strict";
const isThere = require('is-there')
const gd      = require('../helper/gd.js')
const support = require('../helper/support.js')

module.exports = function(server, arg, cb) {

  arg = arg || ''

  const conf = gd.conf()
  let site_local = conf.site_local

  let composer_cmd = 'install';
  if(arg && arg === 'update' || arg === 'install') {
    composer_cmd = arg
    arg = ''
  }
  else if(arg) {
    composer_cmd = 'require'
  }

  if(support.isCommandExcluded('composer') && !isThere(site_local+'/composer.json') && !isThere(site_local.replace('/web', '')+'/composer.json')){
    cb ? cb() : gd.autoClose()
    return;
  }

  server = gd.server(server);


  let composer_path = site_local

  if(!isThere(composer_path+'/composer.json')){
    composer_path = site_local.replace('/web', '');
    if(!isThere(composer_path+'/composer.json')){
      gd.status('Could not locate composer.json file.')
      cb ? cb() : gd.autoClose()
      return;
    }

  }


  gd.log(`Composer ${composer_cmd} ${arg} on ${server}`);



  let cmd = '';

  if(server === 'dev') {
    gd.execraw(`cd ${composer_path} && composer ${composer_cmd} ${arg}`, cb, `Composer ${composer_cmd}ed ${arg} on ${server}`);
    return;
  }

  const C = conf.servers[server];
  const S = C.user + '@' + C.ip;

  cmd+= `ssh -T -p ${C.port} ${S} `;

  cmd+= '"';
  cmd+= 'cd ' + C.site;
  cmd+= ' && ';
  cmd+= `composer ${composer_cmd} ${arg}`;
  cmd+= '"';

  gd.execraw(cmd, cb, `Composer ${composer_cmd}ed ${arg} on ${server}`);
};
