"use strict";
const gd = require('../helper/gd.js');

module.exports = function(server, cb) {

  const conf        = gd.conf()
  const conf_global = gd.globalConf();

  server = gd.server(server);

  var cmd = '';
  var C = conf.servers[server];
  var S = C.user + '@' + C.ip;

  var db_name = gd.db(server);

  if(server === 'dev') {

    var db_user = conf_global.get('db_user');
    var db_pass = conf_global.get('db_pass');

    if(!db_pass) {
      gd.status(`Warning: Your local mysql password is empty, you can change it using 'gd db_pass yourpassword' if you need to`)
    }

    var mysql = `mysql -u${db_user} -p${db_pass} `;

    cmd+= `${mysql} -e 'DROP DATABASE IF EXISTS \`${db_name}\`; CREATE DATABASE \`${db_name}\`'`;
  }
  else{
    cmd+= `ssh -T -p ${C.port} ${S} `;

    cmd+= '"';
    cmd+= '/home/backup/script/gd-cli-create-db.sh ' + db_name;
    cmd+= '"';
  }

  gd.throbber.start(`Creating database '${db_name}' on ${server}`);

  gd.exec(cmd, cb, `Database '${db_name}' created on ${server}`);
};
