"use strict";
const gd        = require('../helper/gd.js')
const userHome  = require('user-home')
const isThere   = require('is-there')
const inquirer  = require('inquirer')

module.exports = function(server, cb) {

  const conf        = gd.conf()
  const conf_local  = gd.localConf()
  const conf_global = gd.globalConf()

  server = gd.server(server)

  let cmd  = '';
  const C  = conf.servers[server];
  const db = gd.db(server);
  const db_user = conf_global.get('db_user')
  const db_pass = conf_global.get('db_pass')

/*
  // Special case for Wordpress
  if(server !== 'dev' && conf.config.type === 'wordpress'){

    const server_url = C.url;

    if(!C.wp_key){
      gd.status(`You must set the private key for this server in your package.json"`);
      exit();
    }
    let cmd_wp = `wp migratedb pull http://${server_url} ${C.wp_key} `

    cmd_wp+= `--find=//${server_url},${conf.site_local} `
    cmd_wp+= `--replace=//${conf.servers.dev.url},${C.site} `
    cmd_wp+= `--skip-replace-guids`
    // gd.dbg(cmd_wp);exit();

    //!\ Cancel cb (wp migratedb do the dump and import)
    gd.execraw(cmd_wp);

    return;
  }
*/
  let file = `${db}.sql.gz`
  let dest = userHome

  const S = C.user + '@' + C.ip;

  if(server !== 'dev'){
    cmd+= `ssh -T -p ${C.port} ${S} `;
  }

  if(server === 'dev'){

    dest = conf.site_root + 'doc'

    if(!isThere(dest)){
      cmd+= `mkdir ${dest} && `
    }

    if(isThere('/Applications/MAMP/Library/bin/mysqldump')){
      cmd+= '/Applications/MAMP/Library/bin/mysqldump'
    }
    else{
      cmd+= 'mysqldump'
    }
    cmd+= ` --add-drop-table -u${db_user} -p${db_pass} ${db} | gzip -9`
  }
  else if(conf_local.get(`${server}.db_server_pass`)){
    const pass = conf_local.get(`${server}.db_server_pass`)
    cmd+= `"mysqldump --add-drop-table -uroot -p${pass} ${db} | gzip -9"`
  }
  else{
    cmd+= `"/home/backup/script/gd-cli-dump.sh ${db}"`
  }

  cmd+= ` > ${dest}/${file}`

  gd.throbber.start(`Getting dump ${db}.sql.gz from ${server}`)

  dest = dest.replace(userHome, '~')


  if(server === 'dev' && !cb){

    cb = function(){

      inquirer.prompt(
      [
        {
          type: "list",
          name: "git",
          message: "Do you want to git add / commit / push ?",
          choices: ['yes', 'no'],
          default: function() { return 'yes' }
        }
      ]).then(function(answers){

        if(answers.git !== 'yes') return;

        gd.execraw(`cd ${conf.site_root} && git add . && git commit -am . && git pull && git push`)
      });
    }
  }


  gd.exec(cmd, cb, `Dump: ${dest}/${file}`)
}
