"use strict";
const gd         = require('../helper/gd.js')
const support    = require('../helper/support.js')
const path       = require('path')
const isThere    = require('is-there')
const cmd_plugin = require('./plugin.js')

module.exports = (theme_folder, server, cb) => {

  const conf    = gd.conf(true)
  const type    = conf.config.type
  const version = conf.config.version

  if(support.isCommandExcluded('gd-theme', true)){
    cb ? cb() : gd.autoClose()
    return;
  }

  const support_json = require('../config/support.json');


  let drupal_theme_conf = null

  let path_files_cwd = __dirname + '/../files/gd-theme/' + type + '/';

  /* COPY PROJECT TYPE SPECIFIC FILES */
  let files = [];
  if(support_json[type][version]
  && support_json[type][version]['theme']
  && support_json[type][version]['theme']['files']){
    files = support_json[type][version]['theme']['files']

    path_files_cwd+= version + '/';
  }
  else if(support_json[type]['all']
       && support_json[type]['all']['theme']
       && support_json[type]['all']['theme']['files']){
    files = support_json[type]['all']['theme']['files']
  }
  // console.log(files)
  if(files[0]){

    const path_files = path.resolve(path_files_cwd);

    if(!isThere(conf.theme + '/' + files[0])){

      let cmds = [];
      for (let file in files) {

        let file_dest = files[file];

        if(file_dest === 'gd.info' || file_dest === 'gd.info.yml'){
          file_dest = file_dest.replace('gd', theme_folder)
          drupal_theme_conf = file_dest
        }

        cmds.push('cp -R ' + path_files + '/' + files[file] + ' ' + conf.theme + '/' + file_dest)
      }

      const cmd = cmds.join(' && ');

      gd.execraw(cmd, function(){

        if(!drupal_theme_conf) return;

        replacefs.sync({
          files: conf.theme + '/' + drupal_theme_conf,
          from: [/THEME/g],
          to: [theme_folder],
        })

      }, `gd-theme files copied`);
    }
  }





  /* INSTALL PROJECT TYPE SPECIFIC PLUGIN */
  let plugins = [];
  if(support_json[type][version]
  && support_json[type][version]['theme']
  && support_json[type][version]['theme']['plugins']){
    plugins = support_json[type][version]['theme']['plugins']
  }
  else if(support_json[type]['all']
       && support_json[type]['all']['theme']
       && support_json[type]['all']['theme']['plugins']){
    plugins = support_json[type]['all']['theme']['plugins']
  }

  if(plugins[0]){
    for (let plugin in plugins) {
      cmd_plugin('dev', plugins[plugin])
    }
  }





  if(!files[0] && !plugins[0]){
    cb ? cb() : gd.autoClose()
    return;
  }
};
