"use strict";
const gd      = require('../helper/gd.js');
const support = require('../helper/support.js');

module.exports = function(server, cb) {

  const conf = gd.conf()
  const type = conf.config.type

  if(support.isCommandExcluded('get-files', true)) {
    cb ? cb() : gd.autoClose()
    return;
  }

  server = gd.server(server);

  const C = conf.servers[server];
  const S = C.user + '@' + C.ip;

  const scp = 'scp -r -P ' + C.port;

  const remote = S + ':' + C.site;
  const local  = conf.site_local;

  const dirs = support.getProjectDirs();

  let cmdline = [];

  for(let d of dirs)
    cmdline.push([scp, remote + d.src, local + d.dest].join(' '));

  if(cmdline.length) {
    gd.throbber.start(`Downloading files from ${server}`);
    gd.exec(cmdline.join(" && "), cb, `Files downloaded from ${server}`);
  }
};