"use strict";
const gd       = require('../helper/gd.js')
const fs       = require('fs')
const path     = require('path')
const userHome = require('user-home')
const mkpath   = require('mkpath')

module.exports = (cb) => {
  
  const conf = gd.conf()
  
  gd.log('Create Bitbar menu');
  
  let tpl = fs.readFileSync(__dirname + '/bitbar/gui.tpl.js', 'utf8');
  
  tpl = tpl.replace('__PKG__', conf.theme);
  tpl = tpl.replace('__GDCLI__', path.resolve(__dirname + '/..'));
  
  const dest = userHome + '/gd-gui/' + conf.name.replace('.','') + '.14s.js';
  
  mkpath.sync(userHome + '/gd-gui', '0777');
  
  fs.writeFile(dest, tpl, (err) => {

    if(err) gd.exit(err);
    
    let cmd = '';

    cmd+= `chmod -R 0777 ${userHome}/gd-gui && `;

    cmd+= 'osascript -e \'quit app "bitbar"\' && open -a bitbar';

    gd.exec(cmd, cb, `File: ${dest.replace(userHome, '~')}`)
  });
};
