"use strict";
const gd   = require('../helper/gd.js');
const fs   = require('fs');
const sudo = require('sudo-prompt');

function gulp(conf, arg, cb) {

  const task = arg || '';

  gd.log(`GULP ${task}!`);

  let cmd = '';
  cmd+= 'cd ' + conf.theme;
  cmd+= ' && ';
  cmd+= 'gulp ' + task;
  
  gd.exec(cmd, cb);
}

module.exports = function(server, arg, cb) {

  const conf = gd.conf()

  server = gd.server(server);

  // Check if node_modules are installed
  fs.lstat(conf.theme + '/node_modules', function(err, stats) {
    if (err || !stats.isDirectory()) {
      
      gd.error('You need to install node modules first');

      gd.log('Please wait, installing node modules... (~ 5 minutes)')

      gd.exec(`cd ${conf.theme} && npm i`, function() {
        gulp(conf, arg, cb);
      }, 'Installing node modules');
    }
    else {
      gulp(conf, arg, cb);
    }
  });

};
