"use strict";
const gd        = require('../helper/gd.js')
const userHome  = require('user-home')
const replacefs = require('replace-in-file')

module.exports = function(server, cb) {

  const conf        = gd.conf()
  const conf_local  = gd.localConf()
  const conf_global = gd.globalConf()

  server = gd.server(server)

  let cmd = '';

  const C  = conf.servers[server];

  const db_name = gd.db(server);
  const db_user = conf_global.get('db_user');
  const db_pass = conf_global.get('db_pass');

  if(!db_pass) {
    gd.status(`Warning: Your local mysql password is empty, you can change it using 'gd db_pass yourpassword' if you need to`)
  }


  const mysql = `mysql -u${db_user} -p${db_pass} `;


  const dump_gz  = userHome + '/' + db_name + '.sql.gz';
  const dump_sql = dump_gz.replace('.sql.gz', '.sql');

  const db_name_local = gd.db('dev');



  cmd+= `${mysql} -e 'DROP DATABASE IF EXISTS \`${db_name_local}\`; CREATE DATABASE \`${db_name_local}\`'`;

  cmd+= ' && ';

  cmd+= mysql + "'" + db_name_local + "' < " + dump_sql;



  /* Wordpress : replace url and path */
  if(server !== 'dev' && conf.config.type === 'wordpress'){

    gd.exec('gunzip -f ' + dump_gz, function(){

      const url_source = new RegExp('//' + C.url, "g")
      const url_dest   = '//' + conf.servers.dev.url

      const path_source = new RegExp(C.site, "g")
      const path_dest   = conf.site_local

      const options = {
        files: dump_sql,
        from: [url_source, path_source],
        to: [url_dest, path_dest],
      }
      // console.log(options);exit();

      replacefs.sync(options)

      gd.throbber.start(`Importing ${dump_sql} locally`)

      gd.exec(cmd, cb, `Dump imported in ${db_name_local}`)

    })

    return;
  }


  cmd = 'gunzip -f ' + dump_gz + ' && ' + cmd




  gd.throbber.start(`Importing ${dump_sql} locally`)

  gd.exec(cmd, cb, `Dump imported in ${db_name_local}`)
}
