'use strict';

const gd      = require('../helper/gd.js');
const support = require('../helper/support.js');

module.exports = function(server, cb) {

  if(support.isCommandExcluded('sync-files', true)) {
    cb ? cb() : gd.autoClose()
    return;
  }

  const conf = gd.conf()
  const type = conf.config.type

  server = gd.server(server);

  const C = conf.servers[server];
  const S = C.user + '@' + C.ip;

  const rsync='rsync -ai --delete -e ssh'; // -q for quiet output

  let remote = S + ':' + C.site;
  let local  = conf.site_local;

  let dirs = support.getProjectDirs();

  let cmdline = [];

  for(let d of dirs)
    cmdline.push([rsync, remote + d.src, local + d.dest].join(' '));

  if(cmdline.length) {
    gd.throbber.start(`Synchronizing files from ${server}`);
    gd.exec(cmdline.join(" && "), cb, `Files synchronized from ${server}`);
  }
};