"use strict";
const fs = require('fs');
const gd = require('../helper/gd.js');

module.exports = function(server, cb) {

  const conf = gd.conf()

  server = gd.server(server);

  var tpl = '';
  var cmd = '';
  var C = conf.servers[server];
  var S = C.user + '@' + C.ip;

  var file = '/etc/apache2/sites-enabled/';

  if(server === 'preprod' || server === 'prod') {
    file+= server + '/';

    tpl = fs.readFileSync(__dirname + '/../files/vhost/' + server + '.conf', 'utf8');
  }
  else { // default vhost
    tpl = fs.readFileSync(__dirname + '/../files/vhost/prod.conf', 'utf8');
  }

  tpl = tpl.replace(/__PATH__/g, C.site);
  tpl = tpl.replace(/__URL__/g, C.url);
  tpl = tpl.replace(/__URL_WWW__/g, 'www.' + C.url);

  file+= conf.name + '.conf';

  gd.log('CREATE VHOST (if does not exists) on ' + server + ' ' + S);
  gd.status('File : ' + file);

  cmd+= `ssh -T -p ${C.port} ${S} `;

  cmd+= '"';
  cmd+= 'test -e ' + file;
  cmd+= ' || ';
  cmd+= 'echo \'' + tpl + '\' > ' + file;
  cmd+= ' && ';
  cmd+= ' service apache2 reload ';
  cmd+= '"';

  var message = '';

  gd.throbber.start();

  gd.exec(cmd, cb, message);
};
