"use strict";
const gd = require('../helper/gd.js');
const support = require('../helper/support.js');

module.exports = (server, arg, cb) => {

  const conf = gd.conf()

  if(support.isCommandExcluded('wordpress', true)){
    cb ? cb() : gd.autoClose()
    return;
  }

  server = gd.server(server);

  if(!arg){
    gd.exit('You must specify a plugin name')
  }
  if(server !== 'dev'){
    gd.exit(`You can install Wordpress plugin only on dev (currently "${server}")`)
  }

  let wp_cmd = 'install'
  let flag   = ' --activate'
  if(arg === 'update') {
    wp_cmd = arg
    arg    = ''
    flag   = ' --all'
  }

  const cmd = `cd ${conf.site_local} && wp plugin ${wp_cmd} ${arg}${flag}`;

  gd.execraw(cmd, cb, `WP Plugin ${arg} ${wp_cmd}d on ${server}`);
};
