<?php

$__symbol_array = [];

function includeSymbols()
{
  global $__symbol_array;

  echo '<svg class="element-invisible">';

  foreach($__symbol_array as $id => $symbol)
    echo '<symbol id="' . $id . '">' . $symbol->children()->asXML() . '</symbol>';

  echo '</svg>';
}


function getSymbol($name)
{
  $path = __DIR__ . '/../dist/img/' . $name . '.svg';

  if(!file_exists($path))
    exit('Le fichier ' . $path . ' est introuvable.');

  $symbol    = simplexml_load_file($path);
  $styleAttr = [ 'fill' ];

  // remove unwanted style attributes
  foreach($symbol->children() as $element)
    foreach($styleAttr as $attr)
      unset($element[$attr]);

  return $symbol;
}


function svg($name, $attributes = [])
{
  global $__symbol_array;
  $id = str_replace(['/'], '-', $name);

  if(!isset($__symbol_array[$id]))
    $__symbol_array[$id] = getSymbol($name);

  $attrTmp = [];

  foreach ($__symbol_array[$id]->attributes() as $attr => $value)
    $attrTmp[$attr] = $value->__toString();

  // merge attributes
  $attributes += $attrTmp;

  // generate attribute strings
  foreach ($attributes as $attribute => $value)
    $attributes[$attribute] = $attribute . '="' . $value . '"';

  echo '<svg ' . implode($attributes, ' ') . '><use xlink:href="#' . $id . '"/></svg>';
}

