<?php

/**
 * Enqueue styles and script
 */
function app_assets() {

  $theme_folder = get_stylesheet_directory_uri();

  # CSS
  wp_enqueue_style('gd-css-plugin', $theme_folder . '/dist/css/plugin.css', array(), false);
  wp_enqueue_style('gd-css-all'   , $theme_folder . '/dist/css/all.css', array(), false);

  # JS
  wp_enqueue_script('gd-is-mobile', $theme_folder . '/src/bower/isMobile/isMobile.min.js', array(), false);
  wp_enqueue_script('gd-viewport' , $theme_folder . '/dist/js/viewport.js', array(), false);
  wp_enqueue_script('gd-js-all'   , $theme_folder . '/dist/js/all.js', array('jquery'), false);
  wp_enqueue_script('gd-js-ie'    , $theme_folder . '/dist/js/ie.js', array('jquery'), false);
  wp_script_add_data('gd-js-ie', 'conditional', 'IE 9');
  // wp_register_script('google-recaptcha', 'https://www.google.com/recaptcha/api.js');
  // wp_enqueue_script('google-recaptcha');
}
add_action('wp_enqueue_scripts', 'app_assets');

/**
 * Remove css js version
 * @param $src
 * @return string
 */
function remove_cssjs_ver($src) {
  if (strpos($src, '?ver=')) {
    $src = remove_query_arg('ver', $src);
  }
  return $src;
}

add_filter('style_loader_src', 'remove_cssjs_ver', 9999);
add_filter('script_loader_src','remove_cssjs_ver', 9999);

// Clean header
remove_action('wp_head', 'rsd_link');
remove_action('wp_head', 'wp_generator');
remove_action('wp_head', 'feed_links', 2);
remove_action('wp_head', 'index_rel_link');
remove_action('wp_head', 'wlwmanifest_link');
remove_action('wp_head', 'feed_links_extra', 3);
remove_action('wp_head', 'start_post_rel_link', 10);
remove_action('wp_head', 'parent_post_rel_link', 10);
remove_action('wp_head', 'adjacent_posts_rel_link', 10);
// Disable emoji in header
remove_action('wp_head', 'print_emoji_detection_script', 7);
remove_action('admin_print_scripts', 'print_emoji_detection_script');
remove_action('wp_print_styles', 'print_emoji_styles');
remove_action('admin_print_styles', 'print_emoji_styles');




