<?php

/**
 * Image sizes
 */
function app_image_sizes() {

  /* OPTIONS
  name   : (optionnal) (default: {width}x{height}) Image style name
  width  : (required ) Image width in px
  height : (optionnal) (default: use {width}) Image height in px
  crop   : (optionnal) (default: true) Whether to crop images to specified width and height (true) or resize (false). An array can specify positioning of the crop area.
  */
  $sizes = array();

/*
  // Describe here where this size is used
  $sizes[] = array(
    'width'  => '800',
    'height' => '400',
  );
*/

  foreach($sizes as $size){

    if(empty($size['width'])){
      continue;
    }
    if(empty($size['height'])){
      $size['height'] = $size['width'];
    }
    if(empty($size['name'])){
      $size['name'] = $size['width'] . 'x' . $size['height'];
    }
    if(!isset($size['crop'])){
      $size['crop'] = true;
    }

    add_image_size(
      $size['name'],
      $size['width'],
      $size['height'],
      $size['crop']
    );
  }

}

add_action('after_setup_theme', 'app_image_sizes');


// Add 'svg' as auhorized file type
function cc_mime_types($mimes) {
  $mimes['svg'] = 'image/svg+xml';
  return $mimes;
}
add_filter('upload_mimes', 'cc_mime_types');








