const gd      = require('../helper/gd');
const request = require('then-request');

const gitlab = {}

gitlab.domain = () => {

  const conf = gd.conf()
  let domain = conf.repository.url.replace(/\:.*/,'').replace(/.*@/,'')

  if(domain === 'git.studio.gd') {
    domain+= ':88'
  }
  return domain;
}
gitlab.headers = () => {
  const conf = gd.conf()
  return {
    headers: {
      'PRIVATE-TOKEN': gd.token()
    }
  }
}



gitlab.issues = {}

gitlab.issues.project = (cb) => {

  const conf = gd.conf()

  request(
    'get',
    `http://${gitlab.domain()}/api/v4/projects/${conf.config.gitlab_id}/issues?state=opened&sort=desc&order_by=updated_at&page=1&${Math.random()}`,
    gitlab.headers()
  ).done(function (r) {
    cb(JSON.parse(r.getBody()));
  });
}



gitlab.project = {}

gitlab.project.get = (cb) => {

  const conf = gd.conf()

  const project = {};

  gitlab.project.infos(function(infos){
    project.infos = infos;

    gitlab.issues.project(function(issues){
      project.issues = issues;

      cb(project)
    })
  })

}


gitlab.project.infos = (cb) => {

  const conf = gd.conf()

  request(
    'get',
    `http://${gitlab.domain()}/api/v4/projects/${conf.config.gitlab_id}`,
    gitlab.headers()
  ).done(function(r) {
    cb(JSON.parse(r.getBody()));
  });

}





module.exports = gitlab