"use strict";
const path     = require('path')
const globule  = require('globule')
const isThere  = require('is-there')
const userHome = require('user-home')
const gd       = require('./gd.js')
const support  = require('./support.js')

const package_finder = {};

package_finder.find = () =>
{
  if(gd.context !== 'clone' && isThere('./package.json')) {
    return path.resolve('./package.json')
  }
  else {
    const glob_path = ['*/package.json','*/*/package.json','*/*/*/package.json','*/*/*/*/package.json','*/*/*/*/*/package.json','*/*/*/*/*/*/package.json','!**/node_modules/**','!**/all/libraries/**','!**/vendor/**','!**/src/bower/**','!**/assets/lib/**']

    let srcBase;
    if(gd.context === 'clone'){
      srcBase = path.resolve(gd.clone_folder)
    }
    else{
      srcBase = path.resolve('.')
    }

    // gd.log(gd.context)
    // gd.log(gd.clone_folder)
    // gd.log(srcBase)

    let glob = globule.find(glob_path, {srcBase})

    if(glob[0]) {
      return srcBase + '/' + glob[0]
    } else { /* Find by walking up parent directories */

      const pkg = require('find-up').sync('package.json', {cwd: srcBase})

      if(!pkg) {

        srcBase = path.resolve('..')
        glob = globule.find(glob_path, {srcBase})
        if(glob[0]) return srcBase + '/' + glob[0]

        srcBase = path.resolve('../..')
        glob = globule.find(glob_path, {srcBase})
        if(glob[0]) return srcBase + '/' + glob[0]

        srcBase = path.resolve('../../..')
        glob = globule.find(glob_path, {srcBase})
        if(glob[0]) return srcBase + '/' + glob[0]

        srcBase = path.resolve('../../../..')
        glob = globule.find(glob_path, {srcBase})
        if(glob[0]) return srcBase + '/' + glob[0]

        srcBase = path.resolve('../../../../..')
        glob = globule.find(glob_path, {srcBase})
        if(glob[0]) return srcBase + '/' + glob[0]

        srcBase = path.resolve('../../../../../..')
        glob = globule.find(glob_path, {srcBase})
        if(glob[0]) return srcBase + '/' + glob[0]

        gd.exit(`\n\n Sorry can't find package.json\n\n`)
      }
      return pkg
    }
  }
};

package_finder.get = (force_reload = false) =>
{
  const pkg = package_finder.find()

  if(force_reload){
    delete require.cache[path.resolve(pkg)]
  }

  const conf = require(pkg)

  if(gd.context !== 'gui'){
    gd.status('Loading ' + pkg.replace(userHome, '~'))
  }

  conf.package_file = pkg
  conf.theme        = path.dirname(pkg)

  if(!conf.config || !conf.config.type) {
    gd.exit(`package.json is invalid: 'config' object not present or incomplete.`)
  }

  if(gd.context === 'clone'){
    conf.site_local = support.findRoot(conf, gd.clone_folder)
  }
  else{
    conf.site_local = support.findRoot(conf)
  }
  conf.site_root = conf.site_local.replace(/\/web|\/www|\/app/i, '/')


  return conf
}

module.exports = package_finder
