#!/usr/bin/env node --harmony
// const P = require('commander')
const gitParse   = require("git-url-parse");
const gd         = require('./helper/gd')
const cmd_gulp   = require('./command/gulp')
const cmd_agg    = require('./command/aggregate')
const cmd_dump   = require('./command/dump')
const cmd_import = require('./command/import-db')
const cmd_open   = require('./command/open')
// require('update-notifier')({pkg:require('./package.json')}).notify()

// P.option('-s, --server <name>', 'Server to use')

// require('./commands.js')(P, 'gui')

// P.parse(process.argv)
gd.context = 'clone'

if(!process.argv[2]){
  console.log('You must specify the git repository url')
  return;
}

server = 'preprod';

if(process.argv[3]){
  server = process.argv[3];
}

var url = process.argv[2];

var git = gitParse(url);
// console.log(git);

if(!git.name){
  console.log('Invalid git url')
  return;
}

require('./command/clone')('dev', () => {

  require('./command/settings')('dev', () => {
    require('./command/composer')('dev', null, () => {
      cmd_dump(server, () => {
        cmd_import(server, () => {
          cmd_agg('dev', false, () => {
            require('./command/get-files')(server, () => {
              cmd_gulp('dev', 'build', () => {
                require('./command/gui')(() => {
                  cmd_open('dev')
                })
              })
            })
          })
        })
      })
    })

  })


}, url, git.name)





